## ros-kinetic-sdhlibrary-cpp 0.2.10

=== demo/Makefile ===
#=======================================================================
#//! \file
#//! \section sdhlibrary_cpp_makefile_demo_general General file information
#//!   \author    Dirk Osswald 
#//!   \date      2007-01-03
#//!  
#//! \brief  
#//!   Makefile for SDH SDHLibrary C project - demo programs.
#//!
#//!   This makefile can generate the demo programs using the sdh C++ library.
#//!   
#//!   For a general description of the project see \ref sdhlibrary_cpp_dox_general "general project information".
#//!
#//! \section sdhlibrary_cpp_makefile_demo_variables Makefile variables
#//!   The variables defined here state project specific settings which are
#//!   then used by the goals and/or by the included, more generic sub makefiles
#//!   like:
#//!   - \ref Makefile-common "Makefile-common"
#//!   - \ref Makefile-rules  "Makefile-rules"
#//!   - \ref Makefile-cygwin "Makefile-cygwin"
#//! 
#//! \section sdhlibrary_cpp_makefile_demo_targets Makefile targets
#//!   - \b \c all : generate everything
#//!     - \b \c build  : generate demo programs 
#//!     - \b \c build_demo : generate demo programs
#//!   - \b \c clean    : clean up generated program files, but not TAGS or doxygen doc
#//!   - \b \c mrproper : clean up all generated files, including TAGS and doxygen doc
#//!
#//! \section sdhlibrary_cpp_makefile_demo_links Links
#//!   - The online documentation for \c gnu \c make can be found at
#//!     <a href="http://www.gnu.org/software/make/manual/make.html">
#//!     http://www.gnu.org/software/make/manual/make.html</a>
#//!  
#//! \section sdhlibrary_cpp_makefile_demo_copyright Copyright
#//!
#//!  Copyright (c) 2007 SCHUNK GmbH & Co. KG
#//!
#//!  <HR>
#//!  \internal
#//!
#//!    \subsection sdhlibrary_cpp_makefile_demo_details SVN related, detailed file specific information:
#//!      $LastChangedBy: Osswald2 $
#//!      $LastChangedDate: 2013-11-27 16:12:49 +0100 (Wed, 27 Nov 2013) $
#//!      \par SVN file revision:
#//!        $Id: Makefile 11045 2013-11-27 15:12:49Z Osswald2 $
#//!
#//!  \subsection sdhlibrary_cpp_makefile_demo_changelog Changelog of this file:
#//!      \include Makefile.log
#//!
#=======================================================================
#//! \cond ignore_me   doxygen cannot parse Makefiles, so just ignore it

.DEFAULT_GOAL := all

########################################################################
# first some variables

#-------------------
# Include common settings 

BASEDIR=..
include ${BASEDIR}/Makefile-settings
#-------------------
#----------------------------
# some directories:


## Source files directory
SRCDIR = .

## Optimization level, can be [0, 1, 2, 3, s]. 
#     0 = turn off optimization. s = optimize for size.
OPT = 0

#----------------------------

#---------------------------- 
## now the target files:
#
# state only the stems (filename without suffix):
#   (These simple programs consist of one source file only,
#    hence the further dependencies are not stated here explicitly but
#    are created implicitly below)
TARGETS_DEMO1=${basename ${wildcard demo-*.cpp}}

ifeq (${HAVE_BOOST},1)
TARGETS_DEMO2=${TARGETS_DEMO1}

${BINDIR}/demo-contact-grasping: EXTRALIBS += boost_thread-mt  boost_system-mt
# Depending on how boost is compiled you might need  boost_date_time-mt  as well.
else
# demo-contact-grasping depends on boost-thread, so remove that demo if boost is not available
TARGETS_DEMO2=${subst demo-contact-grasping,,${TARGETS_DEMO1}}
endif

TARGETS=${TARGETS_DEMO2}

ifeq (${ANY_CAN_AVAILABLE},1)
TARGETS+=cancat
endif


## target files with path but still without suffix:
PTARGETS=${TARGETS:%=${BINDIR}/%}

#----------------------------
# explicit dependencies:


## Dependency file with the implicitly calculated dependencies:
DEMO_DEPS = ${DEPDIR}/demo_deps

# create the dependency file:
${shell rm -f ${DEMO_DEPS};                                  		\
	for t in ${TARGETS} ; do                                        \
	    echo "${BINDIR}/$${t}: ${OBJDIR}/$${t}.o" >> ${DEMO_DEPS} ; \
	    echo "${OBJDIR}/$${t}.o: $${t}.cpp"       >> ${DEMO_DEPS} ; \
	done}

# and include it:
include ${DEMO_DEPS}

#extra dependencies:
${BINDIR}/demo-GetAxisActualAngle: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-GetFingerXYZ: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-temperature: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-test: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-simple: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-radians: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-simple-withtiming: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-simple2: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-simple3: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-dsa:     ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-velocity-acceleration: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-mimic: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-griphand: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-ref: ${OBJDIR}/sdhoptions.o
${BINDIR}/demo-benchmark: ${OBJDIR}/sdhoptions.o
ifeq (${HAVE_BOOST},1)
${BINDIR}/demo-contact-grasping: ${OBJDIR}/dsaboost.o ${OBJDIR}/sdhoptions.o
endif

${BINDIR}/cancat:       ${OBJDIR}/sdhoptions.o

${OBJDIR}/sdhoptions.o: sdhoptions.cpp sdhoptions.h


# demo programs depend on the library (in the static case):
ifeq (${LIBRARY_TYPE},static)
${PTARGETS}: ${PSDHLIBRARY_NAME}
endif

#----------------------------

## Add needed options for the linker :
EXTRALDFLAGS += -L${LIBDIR} -l${SDHLIBRARY_NAME}   
ifeq (${OSNAME},cygwin)
## these are needed for cygwin gcc only (actually for gcc-4.3.2 only)
#  and --enable-auto-import is not understood by Linux gcc! 
EXTRALDFLAGS +=  -Xlinker --enable-auto-import
endif

## add stuff if boost is available
ifeq (${HAVE_BOOST},1)
EXTRAINCDIRS += ${BOOST_INC_DIR}
EXTRALDFLAGS += -L${BOOST_LIB_DIR} ${BOOST_LIBS}
endif   

EXTRAINCDIRS += ../
#----------------------------

#
########################################################################




########################################################################
# now the goals


# Default goal: Make all (programs) 
.PHONY: all
all: build 

# Build the library
.PHONY: build
build: build_demo 

.PHONY: build_demo
build_demo: ${PTARGETS} 


# Clean up generated files 
.PHONY: clean
clean:   cygwin_clean 


# Clean up generated files 
.PHONY: mrproper
mrproper: clean 


# install demo programs in designated directories
.PHONY: install
install: build
	install -d                       ${INSTALL_DIR_BIN}
	install --mode=755 ${PTARGETS}   ${INSTALL_DIR_BIN} 


# Uninstall previously installed stuff
.PHONY: uninstall
uninstall:
	@for f in  ${PTARGETS} ; do                                       \
	  echo "removing ${INSTALL_DIR_BIN}/`basename $$f`${EXESUFFIX}" ; \
	  rm -f  ${INSTALL_DIR_BIN}/`basename $$f`${EXESUFFIX} ;          \
	done
#	rmdir --ignore-fail-on-non-empty ${INSTALL_DIR_BIN}


#
########################################################################


########################################################################
#

# some common settings and targets are defined separately to keep this
# main Makefile more concise
export RELEASE_FILE=../sdh/release.h
include ${COMMON_DIR}/Makefile-common

# Common settings specific for cygwin on pc target platform
include ${COMMON_DIR}/Makefile-cygwin

#overwrite settings (needed for linking):
CC=g++

## For internal use only:
#  The variables and targets to generate test code are defined
#  separately to keep this main Makefile clearly laid out.
-include Makefile-test

#
########################################################################

#-----------------------------------------------------------------------
# emacs settings:
# Local Variables:
# mode: Makefile
# End:
#-----------------------------------------------------------------------
#//! \endcond
########################################################################

=== sdh/Makefile ===
#=======================================================================
#//! \file
#//! \section sdhlibrary_cpp_makefile_sdh_general General file information
#//!   \author    Dirk Osswald 
#//!   \date      2007-05-15
#//!  
#//! \brief  
#//!   Makefile for SDH SDHLibrary C project - library part.
#//!
#//!   This makefile generates the C library itself
#//!   
#//!   For a general description of the project see \ref sdhlibrary_cpp_dox_general "general project information".
#//!
#//! \section sdhlibrary_cpp_makefile_sdh_variables Makefile variables
#//!   The variables defined here state project specific settings which are
#//!   then used by the goals and/or by the included, more generic sub makefiles
#//!   like:
#//!   - \ref Makefile-common "Makefile-common"
#//!   - \ref Makefile-rules  "Makefile-rules"
#//!   - \ref Makefile-cygwin "Makefile-cygwin"
#//! 
#//! \section sdhlibrary_cpp_makefile_sdh_targets Makefile targets
#//!   - \b \c all : generate everything
#//!     - \b \c build  : generate library
#//!     - \b \c build_lib : generate library
#//!   - \b \c clean    : clean up generated object and library files
#//!   - \b \c mrproper : clean up generated object and library files
#//!
#//! \section sdhlibrary_cpp_makefile_sdh_links Links
#//!   - The online documentation for \c gnu \c make can be found at
#//!     <a href="http://www.gnu.org/software/make/manual/make.html">
#//!     http://www.gnu.org/software/make/manual/make.html</a>
#//!  
#//! \section sdhlibrary_cpp_makefile_sdh_copyright Copyright
#//!
#//!  Copyright (c) 2007 SCHUNK GmbH & Co. KG
#//!
#//!  <HR>
#//!  \internal
#//!
#//!    \subsection sdhlibrary_cpp_makefile_sdh_details SVN related, detailed file specific information:
#//!      $LastChangedBy: Osswald2 $
#//!      $LastChangedDate: 2013-01-21 17:11:57 +0100 (Mon, 21 Jan 2013) $
#//!      \par SVN file revision:
#//!        $Id: Makefile 9648 2013-01-21 16:11:57Z Osswald2 $
#//!
#//!  \subsection sdhlibrary_cpp_makefile_sdh_changelog Changelog of this file:
#//!      \include Makefile.log
#//!
#=======================================================================
#//! \cond ignore_me   doxygen cannot parse Makefiles, so just ignore it

.DEFAULT_GOAL := all

########################################################################
# 

#-------------------
# Include common settings 

BASEDIR=..
include ${BASEDIR}/Makefile-settings
#-------------------

## list of header files to install:
INSTALL_HEADER_FILES=${wildcard *.h}


# Source files directory
SRCDIR = .

# Optimization level, can be [0, 1, 2, 3, s]. 
#     0 = turn off optimization. s = optimize for size.
OPT = 0
#----------------------------


#---------------------------- 
# now the target files:

# state only the stems (filename without suffix):

TARGET1=${SDHLIBRARY_NAME}

# target file with path and suffix:
ifeq (${OSNAME},linux)
ifeq (${LIBRARY_TYPE},static)
PTARGET1 = ${LIBDIR}/lib${TARGET1}.a
CLEANTARGET1 = ${LIBDIR}/lib${TARGET1}.so
endif
ifeq (${LIBRARY_TYPE},shared)
PTARGET1 = ${LIBDIR}/lib${TARGET1}.so
CLEANTARGET1 = ${LIBDIR}/lib${TARGET1}.a
endif
endif

ifeq (${OSNAME},cygwin)
ifeq (${LIBRARY_TYPE},static)
PTARGET1 = ${LIBDIR}/lib${TARGET1}.a
CLEANTARGET1 = ${LIBDIR}/${TARGET1}.dll
endif
ifeq (${LIBRARY_TYPE},shared)
PTARGET1 = ${LIBDIR}/${TARGET1}.dll
CLEANTARGET1 = ${LIBDIR}/lib${TARGET1}.a
endif
endif


# All target files:
PTARGETS = ${PTARGET1} 
CLEANTARGETS = ${CLEANTARGET1}

#----------------------------
# The source files: all *.cpp but rs232-vcc.cpp
ALL_SRCS1 = ${subst rs232-vcc.cpp,,${wildcard *.cpp}}

# exclude the ESD CAN stuff if not desired
ifeq (${WITH_ESD_CAN},1)
  SRCS1 = ${ALL_SRCS1}
else
  SRCS1 = ${subst canserial-esd.cpp,,${ALL_SRCS1}}
endif

# exclude the PEAK CAN stuff if not desired
ifeq (${WITH_PEAK_CAN},1)
  SRCS2 = ${SRCS1}
else
  SRCS2 = ${subst canserial-peak.cpp,,${SRCS1}}
endif
#----------------------------

#----------------------------
# The object files:
OBJS1=${SRCS2:%.cpp=${OBJDIR}/%.o}
#----------------------------

#----------------------------
# explicit dependencies:
${PTARGET1}: ${OBJS1}
#----------------------------

#
########################################################################




########################################################################
# now the goals


# Default goal: Make all (library)
.PHONY: all
all: build 


# Build the library
.PHONY: build
build: build_lib

.PHONY: build_lib
build_lib: ${PTARGETS} 


# Clean up generated files.
.PHONY: clean
clean:   cygwin_clean
	rm -f ${PTARGETS} ${CLEANTARGETS}


# Clean up generated files.
.PHONY: mrproper
mrproper: clean 


# install library and header files in designated directories
.PHONY: install
install: build
	install -d                                  ${INSTALL_DIR_INC}
	install -d                                  ${INSTALL_DIR_LIB}
	install --mode=644 ${INSTALL_HEADER_FILES}  ${INSTALL_DIR_INC} 
	install --mode=755 ${PTARGETS}              ${INSTALL_DIR_LIB} 


# Uninstall previously installed stuff
.PHONY: uninstall
uninstall: 
	@for f in  ${PTARGETS} ; do \
	  rm -f  ${INSTALL_DIR_LIB}/$$f ;        \
	done
	@for f in ${INSTALL_HEADER_FILES} ; do   \
	  rm -f  ${INSTALL_DIR_INC}/$$f ;        \
	done
#	# remove include dir if empty
	rmdir --ignore-fail-on-non-empty ${INSTALL_DIR_INC}
#	rmdir --ignore-fail-on-non-empty ${INSTALL_DIR_LIB}


#rules for gnerating library files

# del holds the ASCII code DEL (0x7f)
# it is needed since the braindead libraries ntcan and Pcan_usb contain 
# unexportable symbols that start with this code.
del=${shell echo -n -e "\x7f"}

	
${LIBDIR}/%.dll:
	rm -f $@
	@echo "EXTRALDFLAGS=${EXTRALDFLAGS}"
	@echo "psubst=${patsubst %,-l %,${EXTRALIBS}}" 
	${CPPC} -shared ${CPPFLAGS}  $^  -o $@ ${EXTRALDFLAGS} ${patsubst %,-l %,${EXTRALIBS}} -Wl,--exclude-symbols,${del}NTCAN_NULL_THUNK_DATA:${del}PCAN_USB_NULL_THUNK_DATA

${PTARGET1}: EXTRALDFLAGS += -L${LIBDIR}
${LIBDIR}/%.so:
	${CPPC} -o $@  -Wl,--export-dynamic -shared $^ 

${LIBDIR}/%.a:
	ar -r $@  $^

#
########################################################################


######################################################################
#

# some common settings and targets are defined separately to keep this
# main Makefile more concise
export RELEASE_FILE=./release.h
include ${COMMON_DIR}/Makefile-common

# Common settings specific for cygwin on pc target platform
include ${COMMON_DIR}/Makefile-cygwin

#
########################################################################

#-----------------------------------------------------------------------
# emacs settings:
# Local Variables:
# mode: Makefile
# End:
#-----------------------------------------------------------------------
#//! \endcond
########################################################################

=== debian/changelog ===
ros-kinetic-sdhlibrary-cpp (0.2.10-1xenial) xenial; urgency=high

  * Create LICENSE
  * change license to Apache 2.0
  * export library
  * comment unused parameters
  * remove extra semicolon
  * fix arguments for formatted printing (-Wformat=)
  * demo executables
  * fix CAN handler casting
  * deactivate undefined 'NTCAN_ERROR_NO_BAUDRATE' and 'NTCAN_ERROR_LOM'
  * CMake support
  * remove deprecated dynamic exception specifications (-Wdeprecated)
  * fix ostream comparison
  * SDHLibrary-CPP 0.0.2.10
  * Contributors: Christian Rauch

 -- Christian Rauch <Christian.Rauch@ed.ac.uk>  Thu, 02 May 2019 23:00:00 -0000

=== debian/control ===
Source: ros-kinetic-sdhlibrary-cpp
Section: misc
Priority: extra
Maintainer: Christian Rauch <Christian.Rauch@ed.ac.uk>
Build-Depends: debhelper (>= 9.0.0), cmake
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-sdhlibrary-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: This is SDHLibrary-CPP, the C++ library to access an SDH (SCHUNK Dexterous Hand)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-sdhlibrary-cpp//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
